#!/usr/bin/env python
# -*- coding: utf-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# regen_certs.py
#  
# script de regénération des certificats ssl
#       
###########################################################################
from creole.fonctionseole import get_module_name
from creole.parsedico import parse_dico

import os

def regen_ssl_certs():
    # procédure à lancer et services à redémarrer pour regénérer les certificats
    ssl_procs = {'amon':('/usr/share/eole/gen_certifEole.sh',['apache2','ead-server','ead-web']),
                 'horus':('/usr/share/eole/gen_certifHorus.sh',['apache2','ead-server','ead-web']),
                 'scribe':('/usr/share/eole/gen_certifScribe.sh',['apache2','ead-server','ead-web']),
                 'sentinelle':('/usr/share/eole/gen_certifSentinelle.sh',['apache2','sentinelle','ead-server','ead-web']),
                 'zephir':('/usr/share/eole/gen_certifEole.sh',['zephir','zephir_web','ead-server','ead-web'])
                }
    # gestion d'eole-sso
    conf = parse_dico()
    module = get_module_name()
    local_sso = False
    if conf['adresse_ip_sso'] == conf['adresse_ip_eth0']:
        local_sso = True
        if os.path.isfile('/usr/share/sso/certs/server.pem'):
            os.unlink('/usr/share/sso/certs/server.pem')

    if module in ssl_procs:
        # lancement de la procédure de génération du certificat
        exec_cmd = ssl_procs[module][0]
        if os.path.isfile(exec_cmd):
            res = os.system(exec_cmd)
            if res == 0:
                # redémarrage des services utilisant les certificats
                services = ssl_procs[module][1]
                if local_sso:
                    services.append('eole-sso')
                # cas particulier : eole-sso
                for service in services:
                    if os.path.isfile('/etc/init.d/%s' % service):
                        os.system('/etc/init.d/%s restart' % service)
